extern AFun symPos;

static inline Pos makePos(ATerm e1, int e2, int e3) {
    return (ATerm) ATmakeAppl3(symPos, e1, (ATerm) ATmakeInt(e2), (ATerm) ATmakeInt(e3));
}

#ifdef __cplusplus
static inline bool matchPos(ATerm e, ATerm & e1, int & e2, int & e3) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symPos) return false;
    e1 = ATgetArgument(e, 0);
    if (ATgetType(e1) != AT_APPL) return false;
    e2 = ATgetInt((ATermInt) ATgetArgument(e, 1));
    e3 = ATgetInt((ATermInt) ATgetArgument(e, 2));
    return true;
}
#endif


extern AFun symNoPos;

static inline Pos makeNoPos() {
    return (ATerm) ATmakeAppl0(symNoPos);
}

#ifdef __cplusplus
static inline bool matchNoPos(ATerm e) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symNoPos) return false;
    return true;
}
#endif


extern AFun symFunction;

static inline Expr makeFunction(ATermList e1, Expr e2, Pos e3) {
    return (ATerm) ATmakeAppl3(symFunction, (ATerm) e1, e2, e3);
}

#ifdef __cplusplus
static inline bool matchFunction(ATerm e, ATermList & e1, Expr & e2, Pos & e3) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symFunction) return false;
    e1 = (ATermList) ATgetArgument(e, 0);
    e2 = ATgetArgument(e, 1);
    e3 = ATgetArgument(e, 2);
    return true;
}
#endif


extern AFun symFunction1;

static inline Expr makeFunction1(ATerm e1, Expr e2, Pos e3) {
    return (ATerm) ATmakeAppl3(symFunction1, e1, e2, e3);
}

#ifdef __cplusplus
static inline bool matchFunction1(ATerm e, ATerm & e1, Expr & e2, Pos & e3) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symFunction1) return false;
    e1 = ATgetArgument(e, 0);
    if (ATgetType(e1) != AT_APPL) return false;
    e2 = ATgetArgument(e, 1);
    e3 = ATgetArgument(e, 2);
    return true;
}
#endif


extern AFun symAssert;

static inline Expr makeAssert(Expr e1, Expr e2, Pos e3) {
    return (ATerm) ATmakeAppl3(symAssert, e1, e2, e3);
}

#ifdef __cplusplus
static inline bool matchAssert(ATerm e, Expr & e1, Expr & e2, Pos & e3) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symAssert) return false;
    e1 = ATgetArgument(e, 0);
    e2 = ATgetArgument(e, 1);
    e3 = ATgetArgument(e, 2);
    return true;
}
#endif


extern AFun symWith;

static inline Expr makeWith(Expr e1, Expr e2, Pos e3) {
    return (ATerm) ATmakeAppl3(symWith, e1, e2, e3);
}

#ifdef __cplusplus
static inline bool matchWith(ATerm e, Expr & e1, Expr & e2, Pos & e3) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symWith) return false;
    e1 = ATgetArgument(e, 0);
    e2 = ATgetArgument(e, 1);
    e3 = ATgetArgument(e, 2);
    return true;
}
#endif


extern AFun symIf;

static inline Expr makeIf(Expr e1, Expr e2, Expr e3) {
    return (ATerm) ATmakeAppl3(symIf, e1, e2, e3);
}

#ifdef __cplusplus
static inline bool matchIf(ATerm e, Expr & e1, Expr & e2, Expr & e3) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symIf) return false;
    e1 = ATgetArgument(e, 0);
    e2 = ATgetArgument(e, 1);
    e3 = ATgetArgument(e, 2);
    return true;
}
#endif


extern AFun symOpNot;

static inline Expr makeOpNot(Expr e1) {
    return (ATerm) ATmakeAppl1(symOpNot, e1);
}

#ifdef __cplusplus
static inline bool matchOpNot(ATerm e, Expr & e1) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symOpNot) return false;
    e1 = ATgetArgument(e, 0);
    return true;
}
#endif


extern AFun symOpEq;

static inline Expr makeOpEq(Expr e1, Expr e2) {
    return (ATerm) ATmakeAppl2(symOpEq, e1, e2);
}

#ifdef __cplusplus
static inline bool matchOpEq(ATerm e, Expr & e1, Expr & e2) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symOpEq) return false;
    e1 = ATgetArgument(e, 0);
    e2 = ATgetArgument(e, 1);
    return true;
}
#endif


extern AFun symOpNEq;

static inline Expr makeOpNEq(Expr e1, Expr e2) {
    return (ATerm) ATmakeAppl2(symOpNEq, e1, e2);
}

#ifdef __cplusplus
static inline bool matchOpNEq(ATerm e, Expr & e1, Expr & e2) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symOpNEq) return false;
    e1 = ATgetArgument(e, 0);
    e2 = ATgetArgument(e, 1);
    return true;
}
#endif


extern AFun symOpAnd;

static inline Expr makeOpAnd(Expr e1, Expr e2) {
    return (ATerm) ATmakeAppl2(symOpAnd, e1, e2);
}

#ifdef __cplusplus
static inline bool matchOpAnd(ATerm e, Expr & e1, Expr & e2) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symOpAnd) return false;
    e1 = ATgetArgument(e, 0);
    e2 = ATgetArgument(e, 1);
    return true;
}
#endif


extern AFun symOpOr;

static inline Expr makeOpOr(Expr e1, Expr e2) {
    return (ATerm) ATmakeAppl2(symOpOr, e1, e2);
}

#ifdef __cplusplus
static inline bool matchOpOr(ATerm e, Expr & e1, Expr & e2) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symOpOr) return false;
    e1 = ATgetArgument(e, 0);
    e2 = ATgetArgument(e, 1);
    return true;
}
#endif


extern AFun symOpImpl;

static inline Expr makeOpImpl(Expr e1, Expr e2) {
    return (ATerm) ATmakeAppl2(symOpImpl, e1, e2);
}

#ifdef __cplusplus
static inline bool matchOpImpl(ATerm e, Expr & e1, Expr & e2) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symOpImpl) return false;
    e1 = ATgetArgument(e, 0);
    e2 = ATgetArgument(e, 1);
    return true;
}
#endif


extern AFun symOpUpdate;

static inline Expr makeOpUpdate(Expr e1, Expr e2) {
    return (ATerm) ATmakeAppl2(symOpUpdate, e1, e2);
}

#ifdef __cplusplus
static inline bool matchOpUpdate(ATerm e, Expr & e1, Expr & e2) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symOpUpdate) return false;
    e1 = ATgetArgument(e, 0);
    e2 = ATgetArgument(e, 1);
    return true;
}
#endif


extern AFun symSubPath;

static inline Expr makeSubPath(Expr e1, Expr e2) {
    return (ATerm) ATmakeAppl2(symSubPath, e1, e2);
}

#ifdef __cplusplus
static inline bool matchSubPath(ATerm e, Expr & e1, Expr & e2) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symSubPath) return false;
    e1 = ATgetArgument(e, 0);
    e2 = ATgetArgument(e, 1);
    return true;
}
#endif


extern AFun symOpHasAttr;

static inline Expr makeOpHasAttr(Expr e1, ATerm e2) {
    return (ATerm) ATmakeAppl2(symOpHasAttr, e1, e2);
}

#ifdef __cplusplus
static inline bool matchOpHasAttr(ATerm e, Expr & e1, ATerm & e2) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symOpHasAttr) return false;
    e1 = ATgetArgument(e, 0);
    e2 = ATgetArgument(e, 1);
    if (ATgetType(e2) != AT_APPL) return false;
    return true;
}
#endif


extern AFun symOpPlus;

static inline Expr makeOpPlus(Expr e1, Expr e2) {
    return (ATerm) ATmakeAppl2(symOpPlus, e1, e2);
}

#ifdef __cplusplus
static inline bool matchOpPlus(ATerm e, Expr & e1, Expr & e2) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symOpPlus) return false;
    e1 = ATgetArgument(e, 0);
    e2 = ATgetArgument(e, 1);
    return true;
}
#endif


extern AFun symOpConcat;

static inline Expr makeOpConcat(Expr e1, Expr e2) {
    return (ATerm) ATmakeAppl2(symOpConcat, e1, e2);
}

#ifdef __cplusplus
static inline bool matchOpConcat(ATerm e, Expr & e1, Expr & e2) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symOpConcat) return false;
    e1 = ATgetArgument(e, 0);
    e2 = ATgetArgument(e, 1);
    return true;
}
#endif


extern AFun symCall;

static inline Expr makeCall(Expr e1, Expr e2) {
    return (ATerm) ATmakeAppl2(symCall, e1, e2);
}

#ifdef __cplusplus
static inline bool matchCall(ATerm e, Expr & e1, Expr & e2) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symCall) return false;
    e1 = ATgetArgument(e, 0);
    e2 = ATgetArgument(e, 1);
    return true;
}
#endif


extern AFun symSelect;

static inline Expr makeSelect(Expr e1, ATerm e2) {
    return (ATerm) ATmakeAppl2(symSelect, e1, e2);
}

#ifdef __cplusplus
static inline bool matchSelect(ATerm e, Expr & e1, ATerm & e2) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symSelect) return false;
    e1 = ATgetArgument(e, 0);
    e2 = ATgetArgument(e, 1);
    if (ATgetType(e2) != AT_APPL) return false;
    return true;
}
#endif


extern AFun symVar;

static inline Expr makeVar(ATerm e1) {
    return (ATerm) ATmakeAppl1(symVar, e1);
}

#ifdef __cplusplus
static inline bool matchVar(ATerm e, ATerm & e1) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symVar) return false;
    e1 = ATgetArgument(e, 0);
    if (ATgetType(e1) != AT_APPL) return false;
    return true;
}
#endif


extern AFun symInt;

static inline Expr makeInt(int e1) {
    return (ATerm) ATmakeAppl1(symInt, (ATerm) ATmakeInt(e1));
}

#ifdef __cplusplus
static inline bool matchInt(ATerm e, int & e1) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symInt) return false;
    e1 = ATgetInt((ATermInt) ATgetArgument(e, 0));
    return true;
}
#endif


extern AFun symStr;

static inline Expr makeStr(ATerm e1) {
    return (ATerm) ATmakeAppl1(symStr, e1);
}

#ifdef __cplusplus
static inline bool matchStr(ATerm e, ATerm & e1) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symStr) return false;
    e1 = ATgetArgument(e, 0);
    if (ATgetType(e1) != AT_APPL) return false;
    return true;
}
#endif


extern AFun symPath;

static inline Expr makePath(ATerm e1) {
    return (ATerm) ATmakeAppl1(symPath, e1);
}

#ifdef __cplusplus
static inline bool matchPath(ATerm e, ATerm & e1) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symPath) return false;
    e1 = ATgetArgument(e, 0);
    if (ATgetType(e1) != AT_APPL) return false;
    return true;
}
#endif


extern AFun symUri;

static inline Expr makeUri(ATerm e1) {
    return (ATerm) ATmakeAppl1(symUri, e1);
}

#ifdef __cplusplus
static inline bool matchUri(ATerm e, ATerm & e1) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symUri) return false;
    e1 = ATgetArgument(e, 0);
    if (ATgetType(e1) != AT_APPL) return false;
    return true;
}
#endif


extern AFun symList;

static inline Expr makeList(ATermList e1) {
    return (ATerm) ATmakeAppl1(symList, (ATerm) e1);
}

#ifdef __cplusplus
static inline bool matchList(ATerm e, ATermList & e1) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symList) return false;
    e1 = (ATermList) ATgetArgument(e, 0);
    return true;
}
#endif


extern AFun symBlackHole;

static inline Expr makeBlackHole() {
    return (ATerm) ATmakeAppl0(symBlackHole);
}

#ifdef __cplusplus
static inline bool matchBlackHole(ATerm e) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symBlackHole) return false;
    return true;
}
#endif


extern AFun symUndefined;

static inline Expr makeUndefined() {
    return (ATerm) ATmakeAppl0(symUndefined);
}

#ifdef __cplusplus
static inline bool matchUndefined(ATerm e) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symUndefined) return false;
    return true;
}
#endif


extern AFun symPrimOp;

static inline Expr makePrimOp(int e1, ATermBlob e2, ATermList e3) {
    return (ATerm) ATmakeAppl3(symPrimOp, (ATerm) ATmakeInt(e1), (ATerm) e2, (ATerm) e3);
}

#ifdef __cplusplus
static inline bool matchPrimOp(ATerm e, int & e1, ATermBlob & e2, ATermList & e3) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symPrimOp) return false;
    e1 = ATgetInt((ATermInt) ATgetArgument(e, 0));
    e2 = (ATermBlob) ATgetArgument(e, 1);
    e3 = (ATermList) ATgetArgument(e, 2);
    return true;
}
#endif


extern AFun symAttrs;

static inline Expr makeAttrs(ATermList e1) {
    return (ATerm) ATmakeAppl1(symAttrs, (ATerm) e1);
}

#ifdef __cplusplus
static inline bool matchAttrs(ATerm e, ATermList & e1) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symAttrs) return false;
    e1 = (ATermList) ATgetArgument(e, 0);
    return true;
}
#endif


extern AFun symClosed;

static inline Expr makeClosed(Expr e1) {
    return (ATerm) ATmakeAppl1(symClosed, e1);
}

#ifdef __cplusplus
static inline bool matchClosed(ATerm e, Expr & e1) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symClosed) return false;
    e1 = ATgetArgument(e, 0);
    return true;
}
#endif


extern AFun symRec;

static inline Expr makeRec(ATermList e1, ATermList e2) {
    return (ATerm) ATmakeAppl2(symRec, (ATerm) e1, (ATerm) e2);
}

#ifdef __cplusplus
static inline bool matchRec(ATerm e, ATermList & e1, ATermList & e2) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symRec) return false;
    e1 = (ATermList) ATgetArgument(e, 0);
    e2 = (ATermList) ATgetArgument(e, 1);
    return true;
}
#endif


extern AFun symBool;

static inline Expr makeBool(ATerm e1) {
    return (ATerm) ATmakeAppl1(symBool, e1);
}

#ifdef __cplusplus
static inline bool matchBool(ATerm e, ATerm & e1) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symBool) return false;
    e1 = ATgetArgument(e, 0);
    return true;
}
#endif


extern AFun symNull;

static inline Expr makeNull() {
    return (ATerm) ATmakeAppl0(symNull);
}

#ifdef __cplusplus
static inline bool matchNull(ATerm e) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symNull) return false;
    return true;
}
#endif


extern AFun symBind;

static inline ATerm makeBind(ATerm e1, Expr e2, Pos e3) {
    return (ATerm) ATmakeAppl3(symBind, e1, e2, e3);
}

#ifdef __cplusplus
static inline bool matchBind(ATerm e, ATerm & e1, Expr & e2, Pos & e3) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symBind) return false;
    e1 = ATgetArgument(e, 0);
    if (ATgetType(e1) != AT_APPL) return false;
    e2 = ATgetArgument(e, 1);
    e3 = ATgetArgument(e, 2);
    return true;
}
#endif


extern AFun symBind2;

static inline ATerm makeBind2(ATerm e1, Expr e2) {
    return (ATerm) ATmakeAppl2(symBind2, e1, e2);
}

#ifdef __cplusplus
static inline bool matchBind2(ATerm e, ATerm & e1, Expr & e2) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symBind2) return false;
    e1 = ATgetArgument(e, 0);
    if (ATgetType(e1) != AT_APPL) return false;
    e2 = ATgetArgument(e, 1);
    return true;
}
#endif


extern AFun symInherit;

static inline ATerm makeInherit(Expr e1, ATermList e2, Pos e3) {
    return (ATerm) ATmakeAppl3(symInherit, e1, (ATerm) e2, e3);
}

#ifdef __cplusplus
static inline bool matchInherit(ATerm e, Expr & e1, ATermList & e2, Pos & e3) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symInherit) return false;
    e1 = ATgetArgument(e, 0);
    e2 = (ATermList) ATgetArgument(e, 1);
    e3 = ATgetArgument(e, 2);
    return true;
}
#endif


extern AFun symScope;

static inline Expr makeScope() {
    return (ATerm) ATmakeAppl0(symScope);
}

#ifdef __cplusplus
static inline bool matchScope(ATerm e) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symScope) return false;
    return true;
}
#endif


extern AFun symNoDefFormal;

static inline ATerm makeNoDefFormal(ATerm e1) {
    return (ATerm) ATmakeAppl1(symNoDefFormal, e1);
}

#ifdef __cplusplus
static inline bool matchNoDefFormal(ATerm e, ATerm & e1) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symNoDefFormal) return false;
    e1 = ATgetArgument(e, 0);
    if (ATgetType(e1) != AT_APPL) return false;
    return true;
}
#endif


extern AFun symDefFormal;

static inline ATerm makeDefFormal(ATerm e1, Expr e2) {
    return (ATerm) ATmakeAppl2(symDefFormal, e1, e2);
}

#ifdef __cplusplus
static inline bool matchDefFormal(ATerm e, ATerm & e1, Expr & e2) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symDefFormal) return false;
    e1 = ATgetArgument(e, 0);
    if (ATgetType(e1) != AT_APPL) return false;
    e2 = ATgetArgument(e, 1);
    return true;
}
#endif


extern AFun symTrue;

static inline ATerm makeTrue() {
    return (ATerm) ATmakeAppl0(symTrue);
}

#ifdef __cplusplus
static inline bool matchTrue(ATerm e) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symTrue) return false;
    return true;
}
#endif


extern AFun symFalse;

static inline ATerm makeFalse() {
    return (ATerm) ATmakeAppl0(symFalse);
}

#ifdef __cplusplus
static inline bool matchFalse(ATerm e) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symFalse) return false;
    return true;
}
#endif


extern AFun symPrimOpDef;

static inline ATerm makePrimOpDef(int e1, ATermBlob e2) {
    return (ATerm) ATmakeAppl2(symPrimOpDef, (ATerm) ATmakeInt(e1), (ATerm) e2);
}

#ifdef __cplusplus
static inline bool matchPrimOpDef(ATerm e, int & e1, ATermBlob & e2) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symPrimOpDef) return false;
    e1 = ATgetInt((ATermInt) ATgetArgument(e, 0));
    e2 = (ATermBlob) ATgetArgument(e, 1);
    return true;
}
#endif


extern AFun symAttrRHS;

static inline ATerm makeAttrRHS(Expr e1, Pos e2) {
    return (ATerm) ATmakeAppl2(symAttrRHS, e1, e2);
}

#ifdef __cplusplus
static inline bool matchAttrRHS(ATerm e, Expr & e1, Pos & e2) {
    if (ATgetType(e) != AT_APPL || (AFun) ATgetAFun(e) != symAttrRHS) return false;
    e1 = ATgetArgument(e, 0);
    e2 = ATgetArgument(e, 1);
    return true;
}
#endif


extern ATerm eTrue;
extern ATerm eFalse;
void initNixExprHelpers();

static inline const char * aterm2String(ATerm t) {
    return (const char *) ATgetName(ATgetAFun(t));
}

